VERSION 4.00
Begin VB.Form BarChartForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Bar Chart"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   6690
   Top             =   1170
   Width           =   6810
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "BarChartForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Const NUM_ITEMS = 7
Dim Data(1 To NUM_ITEMS) As Integer


Private Sub Form_Load()
Dim i As Integer

    ' Initialize data.
    For i = 1 To NUM_ITEMS
        Data(i) = Int((100 - 50 + 1) * Rnd + 50)
    Next i
End Sub


' ***********************************************
' Draw the bar chart.
' NUM_ITEMS = # of items in the data array.
' ***********************************************
Private Sub Form_Resize()
Dim i As Integer

    ' Reset the form's ScaleMode so we have a nice
    ' margin at the top, bottom, and sides.
    ScaleLeft = 0
    ScaleWidth = NUM_ITEMS + 2
    ScaleTop = 110
    ScaleHeight = -120
    
    ' Erase the screen.
    Cls
    
    ' Draw the data.
    For i = 1 To NUM_ITEMS
        ' Pick a new fill style.
        FillStyle = i Mod 8
        
        ' Draw a box with i <= X <= i + 1 and
        ' 0 <= Y <= Data(i).
        Line (i, 0)-(i + 1, Data(i)), , B
    Next i
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


