Attribute VB_Name = "Metafile"
Option Explicit

#If Win32 Then
    Declare Function API_MoveTo Lib "gdi32" Alias "MoveToEx" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As Any) As Long
    Declare Function API_LineTo Lib "gdi32" Alias "LineTo" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
#Else
    Declare Function API_MoveTo Lib "GDI" Alias "MoveTo" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Long
    Declare Function API_LineTo Lib "GDI" Alias "LineTo" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
#End If

' ************************************************
' Draw a line to a WMF file.
' ************************************************
Sub WMFDraw(mhdc As Integer, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long)
Dim status As Long

    #If Win32 Then
        status = API_MoveTo(mhdc, 10 * x1, 10 * y1, 0&)
    #Else
        status = API_MoveTo(mhdc, 10 * x1, 10 * y1)
    #End If
    
    status = API_LineTo(mhdc, 10 * x2, 10 * y2)
End Sub



