VERSION 4.00
Begin VB.Form CurveForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Curves"
   ClientHeight    =   4140
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   6690
   Height          =   4830
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   276
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   446
   Top             =   1170
   Width           =   6810
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "CurveForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Resize()
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single
Dim sx As Single
Dim sy As Single
Dim ex As Single
Dim ey As Single
Dim old_mode As Integer

    Cls
    
    ' Draw an ellipse.
    x1 = 10
    y1 = 10
    x2 = ScaleWidth / 2 - 15
    y2 = ScaleHeight / 2 - 15
    If Ellipse(hDC, x1, y1, x2, y2) = 0 Then _
        Exit Sub
    CurrentX = (x1 + x2 - TextWidth("Ellipse")) / 2
    CurrentY = (y1 + y2 - TextHeight("Ellipse")) / 2
    Print "Ellipse"
    
    ' Draw an arc.
    x1 = ScaleWidth / 2 + 5
    x2 = ScaleWidth - 10
    sx = x2
    sy = y2
    ex = (4 * x1 + 3 * x2) / 7
    ey = y1
    If Arc(hDC, x1, y1, x2, y2, sx, sy, ex, ey) = 0 Then _
        Exit Sub
    CurrentX = (x1 + x2) / 2 - TextWidth("Arc ")
    CurrentY = (y1 + y2 - TextHeight("Arc")) / 2
    Print "Arc"
    old_mode = DrawStyle
    DrawStyle = vbDot
    Line (sx, sy)-((x1 + x2) / 2, (y1 + y2) / 2)
    Line -(ex, ey)
    DrawStyle = old_mode
    
    ' Draw a chord.
    x1 = 10
    x2 = ScaleWidth / 2 - 15
    y1 = ScaleHeight / 2 + 5
    y2 = ScaleHeight - 10
    sx = x2
    sy = y2
    ex = (4 * x1 + 3 * x2) / 7
    ey = y1
    If Chord(hDC, x1, y1, x2, y2, sx, sy, ex, ey) = 0 Then _
        Exit Sub
    CurrentX = (x1 + x2) / 2 - TextWidth("Chord ")
    CurrentY = (y1 + y2 - TextHeight("Chord")) / 2
    Print "Chord"
    DrawStyle = vbDot
    Line (sx, sy)-((x1 + x2) / 2, (y1 + y2) / 2)
    Line -(ex, ey)
    DrawStyle = old_mode

    ' Draw a pie slice.
    x1 = ScaleWidth / 2 + 5
    x2 = ScaleWidth - 10
    sx = x2
    sy = y2
    ex = (2 * x1 + 5 * x2) / 7
    ey = y1
    If Pie(hDC, x1, y1, x2, y2, sx, sy, ex, ey) = 0 Then _
        Exit Sub
    CurrentX = (x1 + x2) / 2 - TextWidth("Pie ")
    CurrentY = (y1 + y2 - TextHeight("Pie")) / 2
    Print "Pie"

    Refresh
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub


