Attribute VB_Name = "FillMode"
Option Explicit

#If Win32 Then
    Public Const ALTERNATE = 1
    Public Const WINDING = 2

    Type POINTAPI
        x As Long
        y As Long
    End Type
    
    Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
    Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
    Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
    Declare Function SetPolyFillMode Lib "gdi32" (ByVal hdc As Long, ByVal nPolyFillMode As Long) As Long
    Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
    Declare Function PolyPolygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long) As Long
#Else
    Public Const ALTERNATE = 1
    Public Const WINDING = 2
    
    Type POINTAPI
        x As Integer
        y As Integer
    End Type
    
    Declare Function CreateSolidBrush Lib "GDI" (ByVal crColor As Long) As Integer
    Declare Function SelectObject Lib "GDI" (ByVal hdc As Integer, ByVal hObject As Integer) As Integer
    Declare Function DeleteObject Lib "GDI" (ByVal hObject As Integer) As Integer
    Declare Function SetPolyFillMode Lib "GDI" (ByVal hdc As Integer, ByVal nPolyFillMode As Integer) As Integer
    Declare Function Polygon Lib "GDI" (ByVal hdc As Integer, lpPoints As POINTAPI, ByVal nCount As Integer) As Integer
    Declare Function PolyPolygon Lib "GDI" (ByVal hdc As Integer, lpPoints As POINTAPI, lpPolyCounts As Integer, ByVal nCount As Integer) As Integer
#End If
