VERSION 4.00
Begin VB.Form FloodForm 
   AutoRedraw      =   -1  'True
   Caption         =   "FloodFill"
   ClientHeight    =   4140
   ClientLeft      =   1860
   ClientTop       =   1695
   ClientWidth     =   5025
   Height          =   4830
   Left            =   1800
   LinkTopic       =   "Form1"
   ScaleHeight     =   276
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   335
   Top             =   1065
   Width           =   5145
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "FloodForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim Point(0 To 100) As POINTAPI

#If Win32 Then
    Dim NumPoints(0 To 10) As Long
#Else
    Dim NumPoints(0 To 10) As Integer
#End If
    
    ' Draw a bunch of polygons.
    Point(0).x = 25: Point(0).y = 248
    Point(1).x = 16: Point(1).y = 163
    Point(2).x = 71: Point(2).y = 152
    Point(3).x = 65: Point(3).y = 171
    Point(4).x = 32: Point(4).y = 173
    Point(5).x = 35: Point(5).y = 190
    Point(6).x = 59: Point(6).y = 186
    Point(7).x = 62: Point(7).y = 206
    Point(8).x = 38: Point(8).y = 210
    Point(9).x = 46: Point(9).y = 243
    Point(10).x = 25: Point(10).y = 248
    NumPoints(0) = 11
    Point(11).x = 83: Point(11).y = 169
    Point(12).x = 82: Point(12).y = 239
    Point(13).x = 126: Point(13).y = 241
    Point(14).x = 127: Point(14).y = 214
    Point(15).x = 96: Point(15).y = 222
    Point(16).x = 105: Point(16).y = 166
    Point(17).x = 83: Point(17).y = 169
    NumPoints(1) = 7
    Point(18).x = 153: Point(18).y = 168
    Point(19).x = 144: Point(19).y = 185
    Point(20).x = 143: Point(20).y = 212
    Point(21).x = 156: Point(21).y = 236
    Point(22).x = 175: Point(22).y = 241
    Point(23).x = 190: Point(23).y = 222
    Point(24).x = 192: Point(24).y = 186
    Point(25).x = 177: Point(25).y = 165
    Point(26).x = 153: Point(26).y = 168
    NumPoints(2) = 9
    Point(27).x = 166: Point(27).y = 182
    Point(28).x = 155: Point(28).y = 198
    Point(29).x = 164: Point(29).y = 221
    Point(30).x = 176: Point(30).y = 219
    Point(31).x = 179: Point(31).y = 195
    Point(32).x = 166: Point(32).y = 182
    NumPoints(3) = 6
    Point(33).x = 213: Point(33).y = 165
    Point(34).x = 206: Point(34).y = 184
    Point(35).x = 204: Point(35).y = 215
    Point(36).x = 219: Point(36).y = 235
    Point(37).x = 237: Point(37).y = 236
    Point(38).x = 248: Point(38).y = 211
    Point(39).x = 246: Point(39).y = 176
    Point(40).x = 231: Point(40).y = 164
    Point(41).x = 213: Point(41).y = 165
    NumPoints(4) = 9
    Point(42).x = 225: Point(42).y = 175
    Point(43).x = 217: Point(43).y = 192
    Point(44).x = 219: Point(44).y = 215
    Point(45).x = 230: Point(45).y = 220
    Point(46).x = 239: Point(46).y = 198
    Point(47).x = 234: Point(47).y = 182
    Point(48).x = 225: Point(48).y = 175
    NumPoints(5) = 7
    Point(49).x = 262: Point(49).y = 166
    Point(50).x = 264: Point(50).y = 236
    Point(51).x = 287: Point(51).y = 238
    Point(52).x = 303: Point(52).y = 227
    Point(53).x = 310: Point(53).y = 201
    Point(54).x = 303: Point(54).y = 174
    Point(55).x = 282: Point(55).y = 160
    Point(56).x = 262: Point(56).y = 166
    NumPoints(6) = 8
    Point(57).x = 280: Point(57).y = 182
    Point(58).x = 279: Point(58).y = 217
    Point(59).x = 291: Point(59).y = 213
    Point(60).x = 295: Point(60).y = 197
    Point(61).x = 290: Point(61).y = 184
    Point(62).x = 280: Point(62).y = 182
    NumPoints(7) = 6
    Point(63).x = 158: Point(63).y = 32
    Point(64).x = 142: Point(64).y = 63
    Point(65).x = 105: Point(65).y = 57
    Point(66).x = 131: Point(66).y = 91
    Point(67).x = 121: Point(67).y = 127
    Point(68).x = 160: Point(68).y = 101
    Point(69).x = 200: Point(69).y = 124
    Point(70).x = 190: Point(70).y = 81
    Point(71).x = 213: Point(71).y = 49
    Point(72).x = 174: Point(72).y = 58
    Point(73).x = 158: Point(73).y = 32
    NumPoints(8) = 11
    
    If PolyPolygon(hdc, Point(0), NumPoints(0), 9) = 0 Then Exit Sub

    Refresh
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Dim s As Integer
Dim color As Long
Dim brush As Integer
Dim old_brush As Integer
    
    ' Pick a random color other than black and
    ' the point's current color.
    Do
        color = QBColor(Int(15 * Rnd + 1))
    Loop While color = Point(x, y)
    
    ' Create and select a brush of this color.
    brush = CreateSolidBrush(color)
    old_brush = SelectObject(hdc, brush)
    
    ' Do the flood.
    s = FloodFill(hdc, x, y, vbBlack)
    
    ' Select the old brush and delete the new one.
    brush = SelectObject(hdc, old_brush)
    s = DeleteObject(brush)
    
    Refresh
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


