Attribute VB_Name = "Meta"
Option Explicit

#If Win32 Then
    Declare Function CreateMetaFile Lib "gdi32" Alias "CreateMetaFileA" (ByVal lpString As String) As Long
    Declare Function CloseMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
    Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, lpPoint As Any) As Long
    Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
    Declare Function PlayMetaFile Lib "gdi32" (ByVal hdc As Long, ByVal hMF As Long) As Long
    Declare Function DeleteMetaFile Lib "gdi32" (ByVal hMF As Long) As Long
    Declare Function GetMetaFile Lib "gdi32" Alias "GetMetaFileA" (ByVal lpFileName As String) As Long
#Else
    Declare Function CreateMetaFile Lib "GDI" (ByVal lpString As String) As Integer
    Declare Function CloseMetaFile Lib "GDI" (ByVal hMF As Integer) As Integer
    Declare Function MoveTo Lib "GDI" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Long
    Declare Function LineTo Lib "GDI" (ByVal hdc As Integer, ByVal x As Integer, ByVal y As Integer) As Integer
    Declare Function PlayMetaFile Lib "GDI" (ByVal hdc As Integer, ByVal hMF As Integer) As Integer
    Declare Function DeleteMetaFile Lib "GDI" (ByVal hMF As Integer) As Integer
    Declare Function GetMetaFile Lib "GDI" (ByVal lpFileName As String) As Integer
#End If
