VERSION 4.00
Begin VB.Form PolyForm 
   AutoRedraw      =   -1  'True
   Caption         =   "Polyline, Polygon, and PolyPolygon"
   ClientHeight    =   4140
   ClientLeft      =   1860
   ClientTop       =   1695
   ClientWidth     =   5025
   FillColor       =   &H00FFFF00&
   FillStyle       =   0  'Solid
   Height          =   4830
   Left            =   1800
   LinkTopic       =   "Form1"
   ScaleHeight     =   276
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   335
   Top             =   1065
   Width           =   5145
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "PolyForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim Point(0 To 500) As POINTAPI
#If Win32 Then
    Dim NumPoints(0 To 10) As Long
#Else
    Dim NumPoints(0 To 10) As Integer
#End If
Dim i As Integer
Dim j As Integer

    ' Draw a polyline.
    j = 10
    For i = 0 To ScaleWidth \ 5
        Point(i).x = i * 5
        Point(i).y = j
        If j = 10 Then
            j = 20
        Else
            j = 10
        End If
    Next i
    If Polyline(hdc, Point(0), ScaleWidth \ 5) = 0 Then Exit Sub

    ' Draw a polygon.
    Point(0).x = 158: Point(0).y = 32
    Point(1).x = 142: Point(1).y = 63
    Point(2).x = 105: Point(2).y = 57
    Point(3).x = 131: Point(3).y = 91
    Point(4).x = 121: Point(4).y = 127
    Point(5).x = 160: Point(5).y = 101
    Point(6).x = 200: Point(6).y = 124
    Point(7).x = 190: Point(7).y = 81
    Point(8).x = 213: Point(8).y = 49
    Point(9).x = 174: Point(9).y = 58
    
    If Polygon(hdc, Point(0), 10) = 0 Then Exit Sub

    ' Draw a bunch of polygons.
    Point(0).x = 23: Point(0).y = 241
    Point(1).x = 21: Point(1).y = 149
    Point(2).x = 67: Point(2).y = 148
    Point(3).x = 90: Point(3).y = 166
    Point(4).x = 86: Point(4).y = 190
    Point(5).x = 63: Point(5).y = 202
    Point(6).x = 40: Point(6).y = 204
    Point(7).x = 35: Point(7).y = 240
    Point(8).x = 23: Point(8).y = 241
    NumPoints(0) = 9
    
    Point(9).x = 39: Point(9).y = 183
    Point(10).x = 36: Point(10).y = 166
    Point(11).x = 53: Point(11).y = 160
    Point(12).x = 69: Point(12).y = 172
    Point(13).x = 60: Point(13).y = 184
    Point(14).x = 39: Point(14).y = 183
    NumPoints(1) = 6
    
    Point(15).x = 122: Point(15).y = 154
    Point(16).x = 104: Point(16).y = 177
    Point(17).x = 102: Point(17).y = 215
    Point(18).x = 122: Point(18).y = 237
    Point(19).x = 152: Point(19).y = 239
    Point(20).x = 170: Point(20).y = 210
    Point(21).x = 166: Point(21).y = 167
    Point(22).x = 148: Point(22).y = 153
    Point(23).x = 122: Point(23).y = 154
    NumPoints(2) = 9
    
    Point(24).x = 136: Point(24).y = 170
    Point(25).x = 115: Point(25).y = 189
    Point(26).x = 122: Point(26).y = 214
    Point(27).x = 140: Point(27).y = 222
    Point(28).x = 154: Point(28).y = 203
    Point(29).x = 150: Point(29).y = 176
    Point(30).x = 136: Point(30).y = 170
    NumPoints(3) = 7
    
    Point(31).x = 184: Point(31).y = 150
    Point(32).x = 184: Point(32).y = 238
    Point(33).x = 231: Point(33).y = 239
    Point(34).x = 232: Point(34).y = 212
    Point(35).x = 200: Point(35).y = 219
    Point(36).x = 205: Point(36).y = 150
    Point(37).x = 184: Point(37).y = 150
    NumPoints(4) = 7
    
    Point(38).x = 244: Point(38).y = 152
    Point(39).x = 274: Point(39).y = 188
    Point(40).x = 273: Point(40).y = 237
    Point(41).x = 298: Point(41).y = 237
    Point(42).x = 290: Point(42).y = 188
    Point(43).x = 311: Point(43).y = 152
    Point(44).x = 293: Point(44).y = 148
    Point(45).x = 281: Point(45).y = 167
    Point(46).x = 257: Point(46).y = 142
    Point(47).x = 244: Point(47).y = 152
    NumPoints(5) = 10
    
    If PolyPolygon(hdc, Point(0), NumPoints(0), 6) Then Exit Sub
End Sub



Private Sub mnuFileExit_Click()
    Unload Me
End Sub


