VERSION 4.00
Begin VB.Form PrintersForm 
   Caption         =   "Printers"
   ClientHeight    =   4140
   ClientLeft      =   2325
   ClientTop       =   1545
   ClientWidth     =   4485
   Height          =   4830
   Left            =   2265
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   4485
   Top             =   915
   Width           =   4605
   Begin VB.TextBox PrintersText 
      BeginProperty Font 
         name            =   "Courier New"
         charset         =   0
         weight          =   400
         size            =   8.25
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   0
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   4455
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "PrintersForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
Dim pr As Printer
Dim txt As String
Dim dev As String
Dim prt As String
Dim drv As String
Dim dev_len As Integer
Dim prt_len As Integer
Dim l As Integer

    ' See how long each field is.
    For Each pr In Printers
        l = Len(pr.DeviceName)
        If dev_len < l Then dev_len = l
        
        l = Len(pr.Port)
        If prt_len < l Then prt_len = l
    Next pr
    dev_len = dev_len + 2
    prt_len = prt_len + 2
    
    ' Build the output string.
    txt = "Device" & Space$(dev_len - Len("Device")) & _
          "Port" & Space$(prt_len - Len("Port")) & _
          "Driver" & vbCrLf
    txt = txt & _
          "------" & Space$(dev_len - Len("------")) & _
          "----" & Space$(prt_len - Len("----")) & _
          "------" & vbCrLf
    For Each pr In Printers
        dev = pr.DeviceName
        prt = pr.Port
        drv = pr.DriverName
        txt = txt & dev & Space$(dev_len - Len(dev))
        txt = txt & prt & Space$(prt_len - Len(prt))
        txt = txt & drv & vbCrLf
    Next pr
    
    PrintersText.Text = txt
End Sub

Private Sub Form_Resize()
    PrintersText.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

