VERSION 4.00
Begin VB.Form CircleForm 
   Caption         =   "Circle 2"
   ClientHeight    =   5670
   ClientLeft      =   2115
   ClientTop       =   945
   ClientWidth     =   4830
   Height          =   6360
   Left            =   2055
   LinkTopic       =   "Form1"
   ScaleHeight     =   378
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   322
   Top             =   315
   Width           =   4950
   Begin VB.TextBox YscaleText 
      Height          =   285
      Left            =   2160
      TabIndex        =   9
      Text            =   "0.5"
      Top             =   480
      Width           =   615
   End
   Begin VB.TextBox XscaleText 
      Height          =   285
      Left            =   600
      TabIndex        =   7
      Text            =   "1.0"
      Top             =   480
      Width           =   615
   End
   Begin VB.TextBox DtText 
      Height          =   285
      Left            =   2160
      TabIndex        =   6
      Text            =   "0.1"
      Top             =   45
      Width           =   615
   End
   Begin VB.TextBox TminText 
      Height          =   285
      Left            =   0
      TabIndex        =   4
      Text            =   "0"
      Top             =   45
      Width           =   615
   End
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   4200
      TabIndex        =   3
      Top             =   0
      Width           =   615
   End
   Begin VB.TextBox TmaxText 
      Height          =   285
      Left            =   1200
      TabIndex        =   2
      Text            =   "6.2832"
      Top             =   45
      Width           =   615
   End
   Begin VB.PictureBox Canvas 
      AutoRedraw      =   -1  'True
      Height          =   4815
      Left            =   0
      ScaleHeight     =   -2.2
      ScaleLeft       =   -1.1
      ScaleMode       =   0  'User
      ScaleTop        =   1.1
      ScaleWidth      =   2.2
      TabIndex        =   0
      Top             =   840
      Width           =   4815
   End
   Begin VB.Label Label1 
      Caption         =   "Y scale"
      Height          =   255
      Index           =   3
      Left            =   1560
      TabIndex        =   10
      Top             =   540
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "X scale"
      Height          =   255
      Index           =   2
      Left            =   0
      TabIndex        =   8
      Top             =   540
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "dt"
      Height          =   255
      Index           =   1
      Left            =   1920
      TabIndex        =   5
      Top             =   60
      Width           =   255
   End
   Begin VB.Label Label1 
      Caption         =   "<= t <="
      Height          =   255
      Index           =   0
      Left            =   645
      TabIndex        =   1
      Top             =   60
      Width           =   495
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "CircleForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Const PI = 3.14159


' ************************************************
' Draw the curve on the indicated picture box.
' ************************************************
Sub DrawCurve(pic As PictureBox, start_t As Single, stop_t As Single, dt As Single, xscale As Single, yscale As Single)
Dim x1 As Single
Dim y1 As Single
Dim t As Single

    x1 = xscale * X(start_t)
    y1 = yscale * Y(start_t)
    pic.Cls
    pic.CurrentX = x1
    pic.CurrentY = y1
    
    t = start_t + dt
    Do While t < stop_t
        x1 = xscale * X(t)
        y1 = yscale * Y(t)
        pic.Line -(x1, y1)
        t = t + dt
    Loop
    
    x1 = xscale * X(stop_t)
    y1 = yscale * Y(stop_t)
    pic.Line -(x1, y1)
End Sub



' ************************************************
' The parametric function Y(t).
' ************************************************
Function Y(t As Single) As Single
    Y = Sin(t)
End Function

' ************************************************
' The parametric function X(t).
' ************************************************
Function X(t As Single) As Single
    X = Cos(t)
End Function

Private Sub CmdGo_Click()
Dim tmin As Single
Dim tmax As Single
Dim dt As Single
Dim xscale As Single
Dim yscale As Single

    tmin = CSng(TminText.Text)
    tmax = CSng(TmaxText.Text)
    dt = CSng(DtText.Text)
    xscale = CSng(XscaleText.Text)
    yscale = CSng(YscaleText.Text)
    DrawCurve Canvas, tmin, tmax, dt, xscale, yscale
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


