VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ObjArc"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Public x As Single
Public y As Single
Public r As Single
Public angle1 As Single
Public angle2 As Single
Public aspect As Single

Function ObjectType() As String
    ObjectType = "ARC"
End Function

' ************************************************
' Compute the world coordinate bounds for the
' arc.
' ************************************************
Sub Bound(xmin As Single, ymin As Single, xmax As Single, ymax As Single)
'@
    xmin = x - r
    xmax = x + r
    ymin = y - r
    ymax = y + r
End Sub

' ************************************************
' Write an arc to a file using Write.
' Begin with "ARC" to identify this object.
' ************************************************
Sub FileWrite(filenum As Integer)
    Write #filenum, "ARC", x, y, r, angle1, angle2, aspect
End Sub
' ************************************************
' Draw the arc on a Form, Printer, or
' PictureBox.
' ************************************************
Sub Draw(canvas As Object)
    canvas.Circle (x, y), r, , angle1, angle2, aspect
End Sub

' ************************************************
' Read an arc from a file using Input.
' Assume the "ARC" label has already been read.
' ************************************************
Sub FileInput(filenum As Integer)
    Input #filenum, x, y, r, angle1, angle2, aspect
End Sub

