VERSION 4.00
Begin VB.Form LinesForm 
   Caption         =   "Line vs. Polyline"
   ClientHeight    =   4125
   ClientLeft      =   1140
   ClientTop       =   1815
   ClientWidth     =   6855
   Height          =   4815
   Left            =   1080
   LinkTopic       =   "LineForm"
   ScaleHeight     =   4125
   ScaleWidth      =   6855
   Top             =   1185
   Width           =   6975
   Begin VB.CommandButton Command1 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   4
      Top             =   3720
      Width           =   615
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   3375
      Left            =   3480
      ScaleHeight     =   221
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   221
      TabIndex        =   1
      Top             =   240
      Width           =   3375
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   3375
      Left            =   0
      ScaleHeight     =   221
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   221
      TabIndex        =   0
      Top             =   240
      Width           =   3375
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Line"
      Height          =   255
      Index           =   1
      Left            =   3480
      TabIndex        =   6
      Top             =   0
      Width           =   3375
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Polyline"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   5
      Top             =   0
      Width           =   3375
   End
   Begin VB.Label Label2 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   4560
      TabIndex        =   3
      Top             =   3720
      Width           =   1215
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   1080
      TabIndex        =   2
      Top             =   3720
      Width           =   1215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "LinesForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim Points() As POINTAPI
Dim NumPoints As Integer
Private Sub Command1_Click()
Const NUM_TRIALS = 100

Dim start_time As Single
Dim stop_time As Single
Dim i As Integer
Dim trial As Integer

    Picture1.Cls
    Picture2.Cls
    Label1.Caption = ""
    Label2.Caption = ""
    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer()
    For trial = 1 To NUM_TRIALS
        If Polyline(Picture1.hdc, Points(1), NumPoints) = 0 Then Exit Sub
    Next trial
    stop_time = Timer()
    Picture1.Refresh
    Label1.Caption = Format$(stop_time - start_time, "0.0000")
    DoEvents
    
    start_time = Timer()
    For trial = 1 To NUM_TRIALS
        Picture2.CurrentX = Points(1).x
        Picture2.CurrentY = Points(1).y
        For i = 2 To NumPoints
            Picture2.Line -(Points(i).x, Points(i).y)
        Next i
    Next trial
    stop_time = Timer()
    Picture2.Refresh
    Label2.Caption = Format$(stop_time - start_time, "0.0000")
    
    MousePointer = vbDefault
End Sub

Private Sub Form_Load()
Dim i As Integer
Dim small As Boolean
Dim half As Integer
Dim hgt As Integer
Dim wid As Integer

    NumPoints = Picture1.ScaleWidth
    ReDim Points(1 To NumPoints)
    half = NumPoints \ 2
    
    hgt = Picture1.ScaleHeight
    For i = 1 To half
        Points(i).x = 2 * i
        If small Then
            Points(i).y = 0
        Else
            Points(i).y = hgt
        End If
        small = Not small
    Next i
    
    wid = Picture1.ScaleWidth
    For i = half + 1 To NumPoints
        Points(i).y = 2 * (i - half)
        If small Then
            Points(i).x = 0
        Else
            Points(i).x = wid
        End If
        small = Not small
    Next i
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


