VERSION 4.00
Begin VB.Form LineToForm 
   Caption         =   "Line Method vs. MoveTo/LineTo"
   ClientHeight    =   3585
   ClientLeft      =   1620
   ClientTop       =   1710
   ClientWidth     =   5880
   Height          =   4275
   Left            =   1560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3585
   ScaleWidth      =   5880
   Top             =   1080
   Width           =   6000
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   2640
      TabIndex        =   4
      Top             =   3120
      Width           =   615
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      Height          =   2775
      Left            =   3000
      ScaleHeight     =   181
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   181
      TabIndex        =   2
      Top             =   240
      Width           =   2775
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   2775
      Left            =   120
      ScaleHeight     =   181
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   181
      TabIndex        =   0
      Top             =   240
      Width           =   2775
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "MoveTo and LineTo"
      Height          =   255
      Index           =   1
      Left            =   3000
      TabIndex        =   6
      Top             =   0
      Width           =   2775
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Line Method"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   5
      Top             =   0
      Width           =   2775
   End
   Begin VB.Label Label2 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3840
      TabIndex        =   3
      Top             =   3120
      Width           =   1095
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   960
      TabIndex        =   1
      Top             =   3120
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "LineToForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub CmdGo_Click()
Dim start_time As Single
Dim stop_time As Single

Dim i As Integer
Dim j As Integer
Dim H As Integer
Dim s As Long

    Picture1.Cls
    Picture2.Cls
    MousePointer = vbHourglass
    DoEvents
    
    start_time = Timer()
    With Picture1
        For i = 0 To .ScaleHeight Step 4
            .CurrentX = .ScaleLeft
            .CurrentY = .ScaleTop + i - 1
            For j = 0 To .ScaleWidth Step 4
                Picture1.Line -Step(2, 0)
                Picture1.Line -Step(0, 2)
                Picture1.Line -Step(2, 0)
                Picture1.Line -Step(0, -2)
            Next j
        Next i
    End With
    Picture1.Refresh
    stop_time = Timer()
    Label1.Caption = Format$(stop_time - start_time, "0.0000")
    DoEvents
    
    start_time = Timer()
    H = Picture2.hdc
    For i = 0 To Picture2.ScaleHeight Step 4
#If Win32 Then
        s = MoveToEx(H, 0, i, ByVal 0&)
#Else
        s = MoveTo(H, 0, i)
#End If
        For j = 0 To Picture2.ScaleWidth Step 4
            s = LineTo(H, j + 2, i)
            s = LineTo(H, j + 2, i + 2)
            s = LineTo(H, j + 4, i + 2)
            s = LineTo(H, j + 4, i)
        Next j
    Next i
    Picture2.Refresh
    stop_time = Timer()
    Label2.Caption = Format$(stop_time - start_time, "0.0000")

    MousePointer = vbDefault
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub


