VERSION 4.00
Begin VB.Form LogIndexForm 
   AutoRedraw      =   -1  'True
   Caption         =   "LogIndex"
   ClientHeight    =   5085
   ClientLeft      =   1395
   ClientTop       =   1005
   ClientWidth     =   6915
   Height          =   5775
   Left            =   1335
   LinkTopic       =   "Form1"
   ScaleHeight     =   339
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   461
   Top             =   375
   Width           =   7035
   Begin VB.PictureBox Pal 
      AutoRedraw      =   -1  'True
      Height          =   2460
      Left            =   4440
      ScaleHeight     =   2400
      ScaleWidth      =   2400
      TabIndex        =   1
      Top             =   0
      Width           =   2460
   End
   Begin VB.PictureBox Pict 
      AutoRedraw      =   -1  'True
      Height          =   5055
      Left            =   0
      ScaleHeight     =   4995
      ScaleWidth      =   4320
      TabIndex        =   0
      Top             =   0
      Width           =   4380
   End
   Begin MSComDlg.CommonDialog FileDialog 
      Left            =   4440
      Top             =   2520
      _version        =   65536
      _extentx        =   847
      _extenty        =   847
      _stockprops     =   0
      cancelerror     =   -1  'True
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileLoad 
         Caption         =   "&Load..."
         Shortcut        =   ^L
      End
      Begin VB.Menu mnuFileSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "LogIndexForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Resize()
Dim wid As Single

    Pal.Left = ScaleWidth - Pal.Width
    
    wid = Pal.Left - 3
    If wid < 10 Then wid = 10
    
    Pict.Move Pict.Left, Pict.Top, wid, ScaleHeight
End Sub

' ***********************************************
' Load an image.
' ***********************************************
Private Sub mnuFileLoad_Click()
Dim fname As String

    ' Allow the user to pick a file.
    On Error Resume Next
    FileDialog.filename = "*.BMP;*.ICO;*.RLE;*.WMF;*.DIB"
    FileDialog.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
    FileDialog.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        Beep
        MsgBox "Error selecting file.", , vbExclamation
        Exit Sub
    End If
    On Error GoTo LoadError
    
    fname = Trim$(FileDialog.filename)
    FileDialog.InitDir = Left$(fname, Len(fname) _
        - Len(FileDialog.FileTitle) - 1)
    Caption = "ShowLog [" & fname & "]"
    
    ' Load the picture.
    Pict.Picture = LoadPicture(fname)
    Pict.Refresh
    Pal.Picture = Pict.Picture
    
    ' Display the logical palette colors.
    FillPicture
    Exit Sub
    
LoadError:
    Beep
    MsgBox "Error loading picture " & fname & _
        "." & vbCrLf & Error$, vbExclamation
End Sub

' ***********************************************
' Fill picture box Pal with its logical palette
' colors using palette indexes.
' ***********************************************
Sub FillPicture()
Dim i As Integer
Dim j As Integer
Dim dx As Single
Dim dy As Single
Dim clr As Long

    dx = Pal.ScaleWidth / 16
    dy = Pal.ScaleHeight / 16
    clr = 0
    For i = 0 To 16
        For j = 0 To 16
            Pal.Line (j * dx, i * dy)-Step(dx, dy), _
                clr + &H1000000, BF
            clr = clr + 1
        Next j
    Next i
End Sub

Private Sub Form_Load()
    FillPicture
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub


