VERSION 4.00
Begin VB.Form MkFontForm 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   Caption         =   "MkFont"
   ClientHeight    =   5505
   ClientLeft      =   2040
   ClientTop       =   930
   ClientWidth     =   5040
   Height          =   6195
   Left            =   1980
   LinkTopic       =   "Form1"
   ScaleHeight     =   275.25
   ScaleMode       =   2  'Point
   ScaleWidth      =   252
   Top             =   300
   Width           =   5160
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "MkFontForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

' ***********************************************
' Draw a text string at the indicated position
' using the indicated font.
' ***********************************************
Sub DrawText(txt As String, X As Single, Y As Single, nHeight As Long, nWidth As Long, nEscapement As Long, fnWeight As Long, fbItalic As Long, fbUnderline As Long, fbStrikeOut As Long, fbCharSet As Long, fbOutputPrecision As Long, fbClipPrecision As Long, fbQuality As Long, fbPitchAndFamily As Long, lpszFace As String)
Dim newfont As Long
Dim oldfont As Long

    newfont = CreateFont(nHeight, nWidth, nEscapement, 0, fnWeight, fbItalic, fbUnderline, fbStrikeOut, fbCharSet, fbOutputPrecision, fbClipPrecision, fbQuality, fbPitchAndFamily, lpszFace)
    oldfont = SelectObject(hdc, newfont)

    CurrentX = X
    CurrentY = Y
    Print txt
    
    newfont = SelectObject(hdc, oldfont)
    If DeleteObject(newfont) = 0 Then
        Beep
        MsgBox "Error deleting font object.", vbExclamation
    End If
End Sub





' ************************************************
' Draw an assortment of text samples.
' ************************************************
Sub DrawTheText()
Dim X As Single
Dim Y As Single
Dim R As Single
Dim i As Long
Dim theta As Long
Dim pt As Long
Dim fnt As String
Dim ang As Single

    MousePointer = vbHourglass
    DoEvents
    Cls
    
    ' Different weights.
    X = 10
    CurrentY = 0
    pt = 15
    fnt = "Times New Roman"
    For i = 0 To 900 Step 100
        DrawText "Weight" & Str$(i), X, CurrentY, pt, 0, 0, i, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt
    Next i
    
    ' Tall, thin characters.
    X = 85
    Y = 0
    i = 5
    For pt = 15 To 55 Step 10
        DrawText Format$(pt) & "x" & Format$(i), X, Y, pt, i, 0, 0, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt
        Y = Y + pt * 0.5
    Next pt

    ' Short, wide characters.
    X = 135
    pt = 15
    CurrentY = 0
    For i = 3 To 20 Step 3
        DrawText Format$(pt) & "x" & Format$(i), X, CurrentY, pt, i, 0, 0, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt
    Next i
    
    ' Rotated characters.
    pt = 15
    X = 160
    Y = 185
    For theta = 360 To 3600 Step 360
        DrawText "     Escapement" & Str$(theta), X, Y, pt, 0, theta, 0, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_LH_ANGLES Or CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt
    Next theta
    theta = 0
    DrawText "Escapement" & Str$(theta), 10, 250, pt, 0, theta, 0, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_LH_ANGLES Or CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt
    theta = 3600
    DrawText "Escapement" & Str$(theta), 10, CurrentY, pt, 0, theta, 0, False, False, False, DEFAULT_CHARSET, OUT_TT_ONLY_PRECIS, CLIP_LH_ANGLES Or CLIP_DEFAULT_PRECIS, PROOF_QUALITY, TRUETYPE_FONTTYPE, fnt

    MousePointer = vbDefault
End Sub


Private Sub Form_Load()
    DrawTheText
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


