Attribute VB_Name = "TweenStuff"
Option Explicit

Type Polyline
    NumPoints As Integer
    X() As Integer
    Y() As Integer
End Type

Type PolylineFrame
    NumPolylines As Integer
    Poly() As Polyline
End Type

#If Win32 Then
    Declare Function GetTickCount Lib "kernel32" () As Long
#Else
    Declare Function GetTickCount Lib "User" () As Long
#End If

' ************************************************
' Pause until GetTickCount shows the indicated
' time. This is accurate to within one clock tick
' (55 ms), not counting variability in DoEvents
' and Windows itself.
' ************************************************
Sub WaitTill(next_time As Long)
    Do
        DoEvents
    Loop While GetTickCount() < next_time
End Sub

