VERSION 4.00
Begin VB.Form ScaleAtForm 
   Caption         =   "ScaleAt"
   ClientHeight    =   4425
   ClientLeft      =   2325
   ClientTop       =   780
   ClientWidth     =   4215
   Height          =   5115
   Left            =   2265
   LinkTopic       =   "Form1"
   ScaleHeight     =   4425
   ScaleWidth      =   4215
   Top             =   150
   Width           =   4335
   Begin VB.OptionButton SizeOption 
      Caption         =   "Normal"
      Height          =   255
      Index           =   1
      Left            =   1680
      TabIndex        =   3
      Top             =   4080
      Value           =   -1  'True
      Width           =   855
   End
   Begin VB.OptionButton SizeOption 
      Caption         =   "Little"
      Height          =   255
      Index           =   2
      Left            =   3000
      TabIndex        =   2
      Top             =   4080
      Width           =   855
   End
   Begin VB.OptionButton SizeOption 
      Caption         =   "Big"
      Height          =   255
      Index           =   0
      Left            =   360
      TabIndex        =   1
      Top             =   4080
      Width           =   855
   End
   Begin VB.PictureBox Pict 
      Height          =   3975
      Left            =   0
      ScaleHeight     =   -7
      ScaleLeft       =   -1
      ScaleMode       =   0  'User
      ScaleTop        =   6
      ScaleWidth      =   7
      TabIndex        =   0
      Top             =   0
      Width           =   4215
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "ScaleAtForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim NumSegments As Integer
Dim Segments() As Segment

Dim CurrentT(1 To 3, 1 To 3) As Single
Sub CreateData()
    ' Create the axes.
    MakeSegment 0, 0, 5, 0
    MakeSegment 0, 0, 0, 5

    ' Create an object to manipulate.
    MakeSegment 1, 1, 2, 1
    MakeSegment 2, 1, 2, 2
    MakeSegment 2, 2, 1, 2
    MakeSegment 1, 2, 1, 1

    MakeSegment 1, 1, 2, 2
    MakeSegment 2, 1, 1, 2
End Sub

Sub DrawSegments(pic As Object)
Dim i As Integer
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single

    pic.Cls
    
    TransformPicture CurrentT
    
    For i = 1 To NumSegments
        x1 = Segments(i).fr_tr(1)
        y1 = Segments(i).fr_tr(2)
        x2 = Segments(i).to_tr(1)
        y2 = Segments(i).to_tr(2)
        pic.Line (x1, y1)-(x2, y2)
    Next i
End Sub



Private Sub Form_Load()
    m2Identity CurrentT
    
    CreateData
End Sub
Sub MakeSegment(x1 As Single, y1 As Single, x2 As Single, y2 As Single)
    NumSegments = NumSegments + 1
    ReDim Preserve Segments(1 To NumSegments)
    Segments(NumSegments).fr_pt(1) = x1
    Segments(NumSegments).fr_pt(2) = y1
    Segments(NumSegments).fr_pt(3) = 1
    Segments(NumSegments).to_pt(1) = x2
    Segments(NumSegments).to_pt(2) = y2
    Segments(NumSegments).to_pt(3) = 1
End Sub

' ***********************************************
' Transform all segments except the axes.
' ***********************************************
Sub TransformPicture(M() As Single)
Dim i As Integer

    For i = 1 To 2
        m2PointCopy Segments(i).fr_tr, Segments(i).fr_pt
        m2PointCopy Segments(i).to_tr, Segments(i).to_pt
    Next i
    For i = 3 To NumSegments
        m2Apply Segments(i).fr_pt, M, Segments(i).fr_tr
        m2Apply Segments(i).to_pt, M, Segments(i).to_tr
    Next i
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub Pict_Paint()
    DrawSegments Pict
End Sub


Private Sub SizeOption_Click(Index As Integer)
    Select Case Index
        Case 0  ' Big.
            m2ScaleAt CurrentT, 2, 2, 1.5, 1.5
        Case 1  ' Normal.
            m2Identity CurrentT
        Case 2  ' Little.
            m2ScaleAt CurrentT, 0.5, 0.5, 1.5, 1.5
    End Select
    Pict.Refresh
End Sub


