VERSION 4.00
Begin VB.Form PeanoForm 
   Caption         =   "Peano"
   ClientHeight    =   4335
   ClientLeft      =   2280
   ClientTop       =   1185
   ClientWidth     =   5070
   Height          =   5025
   Left            =   2220
   LinkTopic       =   "Form1"
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   338
   Top             =   555
   Width           =   5190
   Begin VB.TextBox LevelText 
      Height          =   285
      Left            =   600
      MaxLength       =   3
      TabIndex        =   0
      Text            =   "3"
      Top             =   0
      Width           =   375
   End
   Begin VB.PictureBox Canvas 
      AutoRedraw      =   -1  'True
      Height          =   4335
      Left            =   1080
      ScaleHeight     =   285
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   261
      TabIndex        =   3
      Top             =   0
      Width           =   3975
   End
   Begin VB.CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Level"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   495
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "PeanoForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Dim TheLevel As Integer

' Maximum space the curve can take up.
Dim TotalLength As Single

Dim StartX As Integer
Dim StartY As Integer

' ************************************************
' Draw a Peano curve.
' ************************************************
Sub Peano(level As Integer, dx As Single, dy As Single)
Dim dx3 As Single
Dim dy3 As Single

    If level > 0 Then
        dx3 = dx / 3
        dy3 = dy / 3
        Peano level - 1, dx3, dy3
        Peano level - 1, dy3, dx3
        Peano level - 1, dx3, dy3
        Peano level - 1, -dy3, -dx3
        Peano level - 1, -dx3, -dy3
        Peano level - 1, -dy3, -dx3
        Peano level - 1, dx3, dy3
        Peano level - 1, dy3, dx3
        Peano level - 1, dx3, dy3
    Else
        Canvas.Line -Step(dx, dy)
    End If
End Sub


Sub GetParameters()
    If Not IsNumeric(LevelText.Text) Then _
        LevelText.Text = "5"
    TheLevel = CInt(LevelText.Text)
End Sub


Private Sub CmdGo_Click()
Dim i As Integer

    MousePointer = vbHourglass
    DoEvents

    ' Get the parameters.
    GetParameters
    
    ' Draw the curve.
    Canvas.Cls
    Canvas.CurrentX = StartX
    Canvas.CurrentY = StartY
    Peano TheLevel, 0, TotalLength
    
    MousePointer = vbDefault
End Sub


Private Sub Form_Resize()
Dim unit As Single
Dim vunit As Single
Dim hunit As Single

    Canvas.Move Canvas.Left, 0, _
        ScaleWidth - Canvas.Left, ScaleHeight - 1

    ' See how big we can make the curve.
    If Canvas.ScaleHeight < Canvas.ScaleWidth Then
        TotalLength = 0.9 * Canvas.ScaleHeight
    Else
        TotalLength = 0.9 * Canvas.ScaleWidth
    End If

    ' Compute the upper left corner.
    StartX = Canvas.ScaleWidth / 2
    StartY = (Canvas.ScaleHeight - TotalLength) / 2
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


